diff --git a/libs/nio/src/main/java/org/elasticsearch/nio/ChannelFactory.java b/libs/nio/src/main/java/org/elasticsearch/nio/ChannelFactory.java
index 97750af2432c3..423168b35d09b 100644
--- a/libs/nio/src/main/java/org/elasticsearch/nio/ChannelFactory.java
+++ b/libs/nio/src/main/java/org/elasticsearch/nio/ChannelFactory.java
@@ -177,7 +177,9 @@ SocketChannel openNioChannel(InetSocketAddress remoteAddress) throws IOException
 
         SocketChannel acceptNioChannel(ServerChannelContext serverContext) throws IOException {
             ServerSocketChannel rawChannel = serverContext.getChannel().getRawChannel();
+            assert rawChannel.isBlocking() == false;
             SocketChannel socketChannel = accept(rawChannel);
+            assert rawChannel.isBlocking() == false;
             if (socketChannel == null) {
                 return null;
             }
